 type etat = int;;
 type etats = bool array;;
 type transition = etat * int * etat;;
 type automate = {taille : int ; relation : transition list ; initiaux : etats ; finals : etats} ;;
 type mot = int list;;

(*1*)

let auto = {
    taille = 7;
    relation = [(5, 1, 4); (4, 0, 6); (1, 0, 4); (4, 0, 3); (1, 0, 3); (1, 1, 3); (1, 0, 2); (0, 0, 2); (2, 0, 2)];
    initiaux = [|true; true; false; false; false; false; false|];
    finals = [|false; false; false; true; false; false; false|]
  };;

(*2*)

let lecture_lettre a c e =
  let res = Array.make a.taille false in
  let rec parcours liste = match liste with
      | [] -> ()
      | (p, x, q) :: tl when (x = c && e.(p)) -> res.(q) <- true; parcours tl
      | hd :: tl -> parcours tl
  in
  parcours a.relation;
  res;;

(*3*)

let contient_terminal a e =
  let rec parcours fin i =
    if i = fin then false
    else (e.(i) && a.finals.(i)) || parcours fin (i + 1)
  in parcours (a.taille) 0;;

(*4*)

let lecture a mot =
  let rec parcours m e =
    match m with
      | [] -> e
      | c :: tl -> parcours tl (lecture_lettre a c e)
  in contient_terminal a (parcours mot a.initiaux);;

(*5*)

type file = int list ref;;

let enfile (f : file) a = f := a :: !f;;

let estVide f = !f = [];;

let defile f =
 match !f with
  | [] -> failwith "la liste est vide"
  | x :: q -> f := q; x;;


let accessibles a =
 let f = ref [] in
 let n = a.taille in
 for i = 0 to (n - 1) do
  if a.initiaux.(i) then enfile f i
 done;
 let visit = Array.make n false in
 while not (estVide f) do
  let s = defile f in
  if not visit.(s) then
   (visit.(s) <- true;
    let rec parcours sommet liste = match liste with
      | [] -> ()
      | (p, c, q) :: queue when p = sommet -> enfile f q; parcours sommet queue
      | (p, c, q) :: queue -> parcours sommet queue
    in parcours s a.relation)
 done;
 visit;;

(*6*)

let miroir a =
  let rec inverse liste = match liste with
      | [] -> []
      | (p, x, q) :: tl -> (q, x, p) :: (inverse tl) in
  {taille = a.taille; relation = (inverse a.relation); initiaux = a.finals; finals = a.initiaux};;  


(*7*)

let coaccessibles a = 
accessibles (miroir a);;


coaccessibles auto;;

(*8.a*)

let correspondance a = 
let ac = accessibles a in
let coac = coaccessibles a in
  let c = Array.make (a.taille) (- 1) in
  let compt = ref 0 in
  for i = 0 to (a.taille - 1) do
    if ac.(i) && coac.(i) then
      (c.(i) <- !compt;
        incr compt)
  done;
  c,(!compt);;

(*9*)

let emonde a =
  let c,m = correspondance a in
  let rec traite liste = match liste with
      | [] -> []
      | (p, x, q) :: tl when (c.(p)<> (-1))  && (c.(q)<>(-1))  -> (c.(p), x, c.(q)) :: (traite tl)
      | (p, x, q) :: tl -> traite tl
  in
  let traiteTab t =
    let newt = Array.make m false in
    for i = 0 to (a.taille - 1) do
      if t.(i) && c.(i) <> (- 1) then newt.(c.(i)) <- true
    done;
    newt in
  {taille = m;
    relation = (traite a.relation);
    initiaux = traiteTab a.initiaux;
    finals = traiteTab a.finals};;


emonde auto;;

(*10*)

let deterministe auto =
 let card t =
  let tt = Array.length t in
  let c = ref 0 in
  for i = 0 to (tt - 1) do
   if t.(i) then incr c
  done;
  !c in
 let m = Array.make_matrix 2 auto.taille 0 in
 let rec parcours l acc = match l with
   | [] -> acc
   | (p, x, q) :: que -> m.(x).(p) <- m.(x).(p) + 1;
      if m.(x).(p) >= 2 then false else parcours que acc in
 (card auto.initiaux = 1) && (parcours auto.relation true);;

deterministe auto;;